#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>

typedef struct { int w; int p; } coin;

coin coins[500];
int nCoins;


int getMin (int tw, int c)
{
  int i, min;
  coin *coin = coins+c;

  for (i=tw/coin->w; i>=0; i--)
    if (coin->w*i == tw) return coin->p*i;
    else if ((c<nCoins-1) && ((min=getMin(tw-coin->w*i, c+1)))) return min+coin->p*i;

  return 0;
}

int compare (void *_a, void *_b)
{
  coin *a=(coin *)_a, *b=(coin *)_b;
  return (a->p*b->w >= b->p*a->w);
}

int
main()
{
  char b[8192], *cp;
  int T,E,F,min,i;

  fgets(b, 8192, stdin);
  T = atoi(b);

  while (T-- > 0) {
    fgets(b, 8912, stdin);
    E = strtol(b, &cp, 10);
    F = strtol(cp, NULL, 10);

    fgets(b, 8192, stdin);
    nCoins = atoi(b);

    for (i=0; i<nCoins; i++) {
      fgets(b, 8912, stdin);
      coins[i].p = strtol(b, &cp, 10);
      coins[i].w = strtol(cp, NULL, 10);
    }

    qsort (coins, nCoins, sizeof (coin), &compare);

    if (E==F) printf ("The minimum amount of money in the piggy-bank is 0.\n");
    else if ((min=getMin (F-E, 0))) printf ("The minimum amount of money in the piggy-bank is %d.\n", min);
    else printf ("This is impossible.\n");
  }

  exit(0);
}
